' Spielfeld-Editor Version 0.04
' editiert Laser 3.04 und Bankraub 2.00
'
' benoetigt zusaetzlich die Funktionen
'   function editor_frage(byval frage as string) as byte
'   sub editor_leseopt(byval x as ubyte, byval y as ubyte)
'   function editor_leveltest as integer
'   sub editor_meldung(byval text as string)
'   sub editor_setzeopt(byval x as ubyte, byval y as ubyte, byval wert as byte)
'   sub editor_setoptionen(byval set as string)
'   sub editor_spiegelung(byval richtung as string, byval feld as ushort)
'   sub testspiel
' und greift auf weitere Funktionen des Spiels zu:
'   function bildschirm_speichern as any ptr
'   sub bildschirm_zuruecksetzen(speicher as any ptr)
'   sub kleinesFeld(x as integer, y as integer, feld() as ushort)
'   sub ladeinfo(set as string, typ as ubyte, kommentar as string, autor as string, version as ushort)
'   sub laden(set as string, nr as ubyte)
'   sub speichern(set as string, nr as ubyte = 0)
'   sub loeschen(set as string, nr as ubyte)
'   sub verschieben(set as string, nr1 as ubyte, nr2 as ubyte)
'   sub reorganisation(set as string)
'   sub stein(x as ubyte, y as ubyte, nr as ubyte, extra as ubyte)
'   sub zeichnefeldl
'
' benoetigt zusaetzlich die Praeprozessoren
'   EDITOR_STEINBREITE, EDITOR_STEINHOEHE, EDITOR_STEINFAKTOR, EDITOR_LEVELBREITE, EDITOR_LEVELHOEHE
'   EDITOR_LVLBPLUS, EDITOR_LVLHPLUS, EDITOR_LEVELPFAD, EDITOR_EBENEN
'   EDITOR_ZEITMIN, EDITOR_ZEITMAX, EDITOR_ZEITSTEP, EDITOR_WINTITEL
'   editorfeld(1 to EDITOR_LEVELBREITE+EDITOR_LVLBPLUS, 1 to EDITOR_LEVELHOEHE+EDITOR_LVLHPLUS, 0 to EDITOR_EBENEN-1)
' und greift auf weitere Variablen des Spiels zu (shared):
'   _MODUS_, levanz, levelname(nr), zeit, feld(x, y), typ, kommentar, autor, version
'
' Diese Angaben erfolgen ohne Garantie auf Vollstaendigkeit.

type TypUndo
  as ubyte x, y, nr, ebene
  declare constructor(x as ubyte = 0, y as ubyte = 0, nr as ubyte = 0, ebene as ubyte = 0)
end type

type TypEditorumgebung
  as ubyte ebene
  as ubyte undostart, undopos, undoende
  as byte geaendert, undogeschoben
  as TypUndo undo(0 to 255)
end type

declare sub editor(levname as string = "", levnr as ushort = 0)
declare sub editor_ueberblick(levname as string, init as integer = 0)
declare sub editor_hilfe
declare sub editor_level(levname as string, levnr as ushort)
declare sub editor_neu(edit as TypEditorumgebung)
declare sub editor_rubberbox(x1 as integer, y1 as integer, x2 as integer, y2 as integer)
declare function editor_setwahl as string
declare sub editor_levelSpiegeln(richtung as string, ebene as integer)
declare sub editor_undoreset(edit as TypEditorumgebung)
declare sub editor_zeit(x as ubyte, y as ubyte)
declare function inputt(z as ubyte, s as ubyte, txt as string, muster as string, byref ret as string) as string
declare function mustertest(wert as ubyte, muster as ubyte) as byte

constructor TypUndo(x as ubyte = 0, y as ubyte = 0, nr as ubyte = 0, ebene as ubyte = 0)
  this.x = x
  this.y = y
  this.nr = nr
  this.ebene = ebene
end constructor

sub editor(lname as string = "", levnr as ushort = 0)
  dim levname as string = lname
  if right(levname, 4) = ".lev" then levname = left(levname, len(levname)-4)
  if levname <> "" then levname = dir(EDITOR_LEVELPFAD & levname & ".lev")
  windowtitle EDITOR_WINTITEL
  _MODUS_ = 1
  if levname = "" then levname = editor_setwahl
  do
    ladeinfo levname, typ, kommentar, autor, version
    if levanz = 1 then levnr = 1
    if (levnr > 0 and levnr <= levanz) or levanz < 2 then editor_level levname, levnr
    editor_ueberblick levname
    levname = editor_setwahl
  loop until levname = ""
  _MODUS_ = 0
end sub

sub editor_hilfe
  dim speicher as any ptr
  speicher = bildschirm_speichern
  cls
  print
  print " Allgemeine Tastenbelegung:"
  print " --------------------------"
  print " h: Hilfeseite anzeigen"
  print " n: leeres Spielfeld oeffnen"
  print " k: (markiertes) Level aus dem Set loeschen"
  print " o: Set-Einstellungen setzen"
  print " r: Set reorganisieren"
  print " ESC: aktuelle Ansicht verlassen"
  print
  print " Tastenbelegung in der Level-Uebersicht:"
  print " ---------------------------------------"
  print " Pfeiltasten oben/unten: durchblaettern"
  print " Pfeiltasten rechts/links: Level verschieben"
  print " linke Maustaste:  Level zum Editieren oeffnen"
  print " rechte Maustaste: Level markieren"
  print
  print " Tastenbelegung in der Einzelbearbeitung:"
  print " ----------------------------------------"
  print " l/s: Level laden/speichern"
  print " i/e: Level importieren/exportieren (*.export)"
  print " u:   undo - letzter Schritt rueckgaengig"
  print " U:   redo - letztes Undo wiederherstellen"
  print " t:   Testspiel"
  print " +/-: Zeit bzw. Feldoptionen aendern"
  if EDITOR_EBENEN > 1 then print " 1-" & EDITOR_EBENEN & ": Ebene wechseln"
  print " m:   Level im Set verschieben"
  print " Pfeiltasten: Cursor bewegen"
  getkey
  cls
  bildschirm_zuruecksetzen(speicher)
end sub

sub editor_level(lname as string, lnr as ushort)
  dim as TypEditorumgebung edit
  dim as integer mx, my, mb, mx2, my2, mx3, my3
  dim as ubyte x, y, x2, y2, cursorx, cursory
  dim as string taste, eingabe, eingabe2, levname = lname
  dim as ushort levnr = lnr
  if levanz = 0 then
    levnr = 1
    editor_neu edit
    speichern levname, 1
    reorganisation(levname)
  end if
  if levnr < 1 or levnr > levanz + 1 then levnr = levanz + 1
  if levnr > levanz then editor_neu edit else laden levname, levnr
  editor_undoreset edit
  windowtitle EDITOR_WINTITEL & " - " & levname & ", Level " & levnr & " von " & levanz
  cls
  zeichnefeld
  cursorx = 1
  cursory = 1
  line (0, 0)-step(EDITOR_STEINBREITE-1, EDITOR_STEINHOEHE-1), &hff0000, b
  locate 1, 66
  print "Zeit: " & zeit & "    "
  do
    getmouse mx, my,, mb
    if mx < 0 or my < 0 or mx > 640 or my > 480 then mb = -1
    taste = inkey
    if taste = chr(27) or taste = chr(255) & "k" then
      if edit.geaendert then
        if editor_frage("Das Level wurde geaendert.\nWollen Sie trotzdem beenden?") = 0 then continue do
      end if
      if taste = chr(255) & "k" then end
      exit sub
    end if
    x = int(mx/EDITOR_STEINBREITE) + 1
    y = int(my/EDITOR_STEINHOEHE) + 1
    if mb = 1 then ' linke Maustaste: Stein auswaehlen bzw. setzen
      if y < 4 and (editorfeld(x, y, edit.ebene) <> 0 or (x = 1 and y = 1)) then
        stein cursorx, cursory, editorfeld(cursorx, cursory, edit.ebene), edit.ebene
        cursorx = x
        cursory = y
        line ((cursorx-1)*EDITOR_STEINBREITE, (cursory-1)*EDITOR_STEINHOEHE) _
             -step(EDITOR_STEINBREITE-1, EDITOR_STEINHOEHE-1), &hff0000, b
      elseif x > EDITOR_LVLBPLUS and x <= EDITOR_LVLBPLUS+EDITOR_LEVELBREITE and _
             y > EDITOR_LVLHPLUS and y <= EDITOR_LVLHPLUS+EDITOR_LEVELHOEHE  and _
             cursory < 4 then
        if editorfeld(x, y, edit.ebene) <> editorfeld(cursorx, cursory, edit.ebene) then
          edit.undo(edit.undopos) = TypUndo(x, y, editorfeld(x, y, edit.ebene), edit.ebene)
          edit.undopos += 1
          edit.undoende = edit.undopos
          if edit.undopos = edit.undostart then edit.undostart += 1 : edit.undogeschoben = -1
          editorfeld(x, y, edit.ebene) = editorfeld(cursorx, cursory, edit.ebene)
          stein x, y, editorfeld(x, y, edit.ebene), edit.ebene
          edit.geaendert = -1
        end if
        editor_zeit(cursorx, cursory)
      end if
    end if

    if mb = 2 and x > EDITOR_LVLBPLUS and x <= EDITOR_LVLBPLUS+EDITOR_LEVELBREITE and _
                  y > EDITOR_LVLHPLUS and y <= EDITOR_LVLHPLUS+EDITOR_LEVELHOEHE  then
      ' rechte Maustate: Optionen einstellen
      stein cursorx, cursory, editorfeld(cursorx, cursory, edit.ebene), edit.ebene
      cursorx = x
      cursory = y
      line ((cursorx-1)*EDITOR_STEINBREITE, (cursory-1)*EDITOR_STEINHOEHE) _
           -step(EDITOR_STEINBREITE-1, EDITOR_STEINHOEHE-1), &hff0000, b
      editor_leseopt(cursorx, cursory)
      do
        getmouse mx2, my2,, mb
        sleep 1
      loop until mb = 0
    end if

    if mb = 4 and cursory < 4 then ' mittlere Maustaste: Bloecke fuellen
      if x <= EDITOR_LVLBPLUS then x = EDITOR_LVLBPLUS + 1
      if x > EDITOR_LVLBPLUS+EDITOR_LEVELBREITE then x = EDITOR_LVLBPLUS+EDITOR_LEVELBREITE
      if y <= EDITOR_LVLHPLUS then y = EDITOR_LVLHPLUS + 1
      if y > EDITOR_LVLHPLUS+EDITOR_LEVELHOEHE then y = EDITOR_LVLHPLUS+EDITOR_LEVELHOEHE
      mx2 = mx : mx3 = mx
      my2 = my : my3 = my
      editor_rubberbox mx, my, mx3, my3
      do
        sleep 1
        getmouse mx2, my2,, mb
        if mx2 <> mx3 or my2 <> my3 then
          editor_rubberbox mx, my, mx3, my3
          editor_rubberbox mx, my, mx2, my2
          mx3 = mx2
          my3 = my2
        end if
      loop until mb < 1
      if mb = -1 then continue do
      editor_rubberbox mx, my, mx3, my3
      x2 = int(mx2/EDITOR_STEINBREITE)+1
      y2 = int(my2/EDITOR_STEINHOEHE)+1
      if x2 <= EDITOR_LVLBPLUS then x2 = EDITOR_LVLBPLUS + 1
      if x2 > EDITOR_LVLBPLUS+EDITOR_LEVELBREITE then x2 = EDITOR_LVLBPLUS+EDITOR_LEVELBREITE
      if y2 <= EDITOR_LVLHPLUS then y2 = EDITOR_LVLHPLUS + 1
      if y2 > EDITOR_LVLHPLUS+EDITOR_LEVELHOEHE then y2 = EDITOR_LVLHPLUS+EDITOR_LEVELHOEHE
      if x > x2 then swap x, x2
      if y > y2 then swap y, y2
      for i as ubyte = x to x2
        for k as ubyte = y to y2
          if editorfeld(i, k, edit.ebene) <> editorfeld(cursorx, cursory, edit.ebene) then
            edit.undo(edit.undopos) = TypUndo(i, k, editorfeld(i, k, edit.ebene), edit.ebene)
            edit.undopos += 1
            edit.undoende = edit.undopos
            if edit.undopos = edit.undostart then edit.undostart += 1 : edit.undogeschoben = -1
            editorfeld(i, k, edit.ebene) = editorfeld(cursorx, cursory, edit.ebene)
            stein i, k, editorfeld(i, k, edit.ebene), edit.ebene
            edit.geaendert = -1
          end if
        next
      next
    end if

    select case taste
      case "h", "H"  ' Hilfe
        editor_hilfe
      case "r", "R"  ' Level reorganisieren
        if editor_frage("Levelset reorganisieren?") then reorganisation(levname)
      case "t", "T"  ' Testspiel
        if editor_leveltest then testspiel
      case "n", "N"  ' neues (leeres) Level
        if edit.geaendert then
          if editor_frage("Das Level wurde geaendert.\nWollen Sie jetzt trotzdem\nein neues Level erstellen?") = 0 then
            continue do
          end if
        end if
        levnr = levanz + 1
        editor_neu edit
        windowtitle EDITOR_WINTITEL & " - " & levname & ", Level " & levnr & " von " & levanz
        if cursory > 3 then
          cursorx = 1
          cursory = 1
        end if
        line ((cursorx-1)*EDITOR_STEINBREITE, (cursory-1)*EDITOR_STEINHOEHE) _
             -step(EDITOR_STEINBREITE-1, EDITOR_STEINHOEHE-1), &hff0000, b
      case "l", "L"  ' Level laden
        if edit.geaendert then
          if editor_frage("Das Level wurde geaendert.\nWollen Sie trotzdem neu laden?") = 0 then
            continue do
          end if
        end if
        eingabe = inputt(1, 66, "Laden  ", "000", "")
        if eingabe = chr(255) + "k" then taste=chr(255)+"k" : exit sub
        if val(eingabe) > 0 and val(eingabe) <= levanz then
          levnr = val(eingabe)
          laden levname, levnr
          editor_undoreset edit
          edit.undogeschoben = 0
          for i as ubyte = 1 to EDITOR_LEVELBREITE + EDITOR_LVLBPLUS
            editorfeld(i, 1, edit.ebene) = editorfeld(i, 1, edit.ebene)
            editorfeld(i, 2, edit.ebene) = editorfeld(i, 2, edit.ebene)
            for k as ubyte = 1 to EDITOR_LEVELHOEHE + EDITOR_LVLHPLUS
              stein i, k, editorfeld(i, k, edit.ebene), edit.ebene
            next
          next
          if cursory > 3 then
            cursorx = 1
            cursory = 1
          end if
          line ((cursorx-1)*EDITOR_STEINBREITE, (cursory-1)*EDITOR_STEINHOEHE) _
               -step(EDITOR_STEINBREITE-1, EDITOR_STEINHOEHE-1), &hff0000, b
        end if
        editor_zeit(cursorx, cursory)
        windowtitle EDITOR_WINTITEL & " - " & levname & ", Level " & levnr & " von " & levanz
      case "s", "S"  ' Level speichern
        if editor_leveltest then
          eingabe = inputt(1, 66, "Speichern ", "000", str(levnr))
          if eingabe = chr(255) & "k" then taste = chr(255) & "k" : exit sub
          if val(eingabe) > 0 and val(eingabe) <= levanz + 1 then
            levnr = val(eingabe)
            speichern levname, levnr
            edit.geaendert = 0
          end if
          editor_zeit(cursorx, cursory)
          windowtitle EDITOR_WINTITEL & " - " & levname & ", Level " & levnr & " von " & levanz
        end if
      case "i", "I"  ' Level impotzieren
        if edit.geaendert then
          if editor_frage("Das Level wurde geaendert.\nWollen Sie trotzdem neu laden?") = 0 then
            continue do
          end if
        end if
        eingabe = inputt(1, 64, "Import ", "dddddddd", "")
        if eingabe = chr(255) & "k" then taste = chr(255) & "k" : exit sub
        if eingabe <> "" and eingabe <> chr(27) then
          laden eingabe & ".export"
          editor_undoreset edit
          locate 1, 64
          print string(15, 32)
          for i as ubyte = 1 tO EDITOR_LEVELBREITE + EDITOR_LVLBPLUS
            editorfeld(i, 1, edit.ebene) = editorfeld(i, 1, edit.ebene)
            editorfeld(i, 2, edit.ebene) = editorfeld(i, 2, edit.ebene)
            for k as ubyte = 1 tO EDITOR_LEVELHOEHE + EDITOR_LVLHPLUS
              stein i, k, editorfeld(i, k, edit.ebene), edit.ebene
            next
          next
          line (0, 0)-step(EDITOR_STEINBREITE-1, EDITOR_STEINHOEHE-1), &hff0000, b
          if cursory > 3 then
            cursorx = 1
            cursory = 1
          end if
          line ((cursorx-1)*EDITOR_STEINBREITE, (cursory-1)*EDITOR_STEINHOEHE) _
               -step(EDITOR_STEINBREITE-1, EDITOR_STEINHOEHE-1), &hff0000, b
        end if
        editor_zeit(cursorx, cursory)
        windowtitle EDITOR_WINTITEL & " - " & levname & ", " & levanz & " Level"
      case "e", "E"  ' Level exportieren
        editor_leveltest
        eingabe = inputt(1, 64, "Export ", "dddddddd", "")
        if eingabe = chr(255) & "k" then taste = chr(255)+"k" : exit sub
        if eingabe <> "" and eingabe <> chr(27) then
          speichern eingabe & ".export"
          locate 1, 64
          print string(15, 32)
        end if
        editor_zeit(cursorx, cursory)
      case "k", "K"  ' aktuelles Level loeschen
        if levnr > levanz then continue do
        if editor_frage("Wollen Sie das Level Nr. " & levnr & "\nwirklich aus dem Set loeschen?") = 0 then
          continue do
        end if
        loeschen levname, levnr
        levnr = levanz + 1
        editor_neu edit
        if cursory > 3 then
          cursorx = 1
          cursory = 1
        end if
        line ((cursorx-1)*EDITOR_STEINBREITE, (cursory-1)*EDITOR_STEINHOEHE) _
             -step(EDITOR_STEINBREITE-1, EDITOR_STEINHOEHE-1), &hff0000, b
        editor_zeit(cursorx, cursory)
        windowtitle EDITOR_WINTITEL & " - " & levname & ", Level " & levnr & " von " & levanz
      case "m", "M"  ' Level verschieben
        eingabe = inputt(1, 66, "Schieben ", "000", "")
        if eingabe = chr(255) + "k" then taste = chr(255)+"k" : exit sub
        if val(eingabe) > 0 and val(eingabe) <= levanz then
          eingabe2 = inputt(1, 66, eingabe & " nach ", "000", "")
          if eingabe2 = chr(255) + "k" then taste = chr(255)+"k" : exit sub
          if val(eingabe) > 0 and val(eingabe) <= levanz then
            verschieben levname, val(eingabe), val(eingabe2)
          end if
        end if
        editor_zeit(cursorx, cursory)
      case "o", "O"  ' Setoptionen
        editor_setoptionen levname
      case "u"       ' undo
        if edit.undopos <> edit.undostart then
          edit.undopos -= 1
          locate 1, 1
          with edit.undo(edit.undopos)
            dim as integer temp = editorfeld(.x, .y, edit.ebene)
            editorfeld(.x, .y, edit.ebene) = .nr
            .nr = temp
            stein .x, .y, editorfeld(.x, .y, edit.ebene), edit.ebene
          end with
          if edit.undopos = edit.undostart and edit.undogeschoben = 0 then edit.geaendert = 0
        end if
      case "U"       ' redo
        if edit.undopos <> edit.undoende then
          locate 1, 1
          with edit.undo(edit.undopos)
            dim as integer temp = editorfeld(.x, .y, edit.ebene)
            editorfeld(.x, .y, edit.ebene) = .nr
            .nr = temp
            stein .x, .y, editorfeld(.x, .y, edit.ebene), edit.ebene
          end with
          edit.undopos += 1
          edit.geaendert = 1
        end if
      case "+"       ' Zaehler erhoehen
        if cursory < 4 then
          if zeit < EDITOR_ZEITMAX then
            zeit += EDITOR_ZEITSTEP
            if cursory < 4 then
              locate 1, 66
              print "Zeit: " & zeit & "    "
            else
              editor_leseopt(cursorx, cursory)
            end if
          end if
        else
          editor_setzeopt(cursorx, cursory, 1)
          line ((cursorx-1)*EDITOR_STEINBREITE, (cursory-1)*EDITOR_STEINHOEHE) _
               -step(EDITOR_STEINBREITE-1, EDITOR_STEINHOEHE-1), &hff0000, b
        end if
      case "-"       ' Zaehler vermindern
        if cursory < 4 then
          if zeit > EDITOR_ZEITMIN Then
            zeit -= EDITOR_ZEITSTEP
            locate 1, 66
            print "Zeit: " & zeit & "    "
          end if
        else
          editor_setzeopt(cursorx, cursory, -1)
          line ((cursorx-1)*EDITOR_STEINBREITE, (cursory-1)*EDITOR_STEINHOEHE) _
               -step(EDITOR_STEINBREITE-1, EDITOR_STEINHOEHE-1), &hff0000, b
        end if
      ' Level schieben
      case chr(255, 75)
        dim temp(EDITOR_LVLHPLUS + EDITOR_LEVELHOEHE) as integer
        for e as integer = 0 to EDITOR_EBENEN-1
          for k as integer = EDITOR_LVLHPLUS+1 to EDITOR_LVLHPLUS + EDITOR_LEVELHOEHE
            temp(k) = editorfeld(EDITOR_LVLBPLUS+1, k, e)
            for i as integer = EDITOR_LVLBPLUS+2 to EDITOR_LVLBPLUS + EDITOR_LEVELBREITE
              editorfeld(i-1, k, e) = editorfeld(i, k, e)
              if e = edit.ebene then stein i-1, k, editorfeld(i-1, k, e), e
            next
            editorfeld(EDITOR_LVLBPLUS + EDITOR_LEVELBREITE, k, e) = temp(k)
            if e = edit.ebene then stein EDITOR_LVLBPLUS + EDITOR_LEVELBREITE, k, temp(k)
          next
        next
        editor_undoreset edit
        edit.geaendert = -1
      case chr(255, 77)
        dim temp(EDITOR_LVLHPLUS + EDITOR_LEVELHOEHE) as integer
        for e as integer = 0 to EDITOR_EBENEN-1
          for k as integer = EDITOR_LVLHPLUS+1 to EDITOR_LVLHPLUS + EDITOR_LEVELHOEHE
            temp(k) = editorfeld(EDITOR_LVLBPLUS+EDITOR_LEVELBREITE, k, e)
            for i as integer = EDITOR_LVLBPLUS + EDITOR_LEVELBREITE to EDITOR_LVLBPLUS+2 step -1
              editorfeld(i, k, e) = editorfeld(i-1, k, e)
              if e = edit.ebene then stein i, k, editorfeld(i, k, e), e
            next
            editorfeld(EDITOR_LVLBPLUS+1, k, e) = temp(k)
            if e = edit.ebene then stein EDITOR_LVLBPLUS+1, k, temp(k)
          next
        next
        editor_undoreset edit
        edit.geaendert = -1
      case chr(255, 72)
        dim temp(EDITOR_LVLBPLUS + EDITOR_LEVELBREITE) as integer
        for e as integer = 0 to EDITOR_EBENEN-1
          for i as integer = EDITOR_LVLBPLUS+1 to EDITOR_LVLBPLUS + EDITOR_LEVELBREITE
            temp(i) = editorfeld(i, EDITOR_LVLHPLUS+1, e)
            for k as integer = EDITOR_LVLHPLUS+2 to EDITOR_LVLHPLUS + EDITOR_LEVELHOEHE
              editorfeld(i, k-1, e) = editorfeld(i, k, e)
              if e = edit.ebene then stein i, k-1, editorfeld(i, k-1, e), e
            next
            editorfeld(i, EDITOR_LVLHPLUS + EDITOR_LEVELHOEHE, e) = temp(i)
            if e = edit.ebene then stein i, EDITOR_LVLHPLUS + EDITOR_LEVELHOEHE, temp(i)
          next
        next
        editor_undoreset edit
        edit.geaendert = -1
      case chr(255, 80)
        dim temp(EDITOR_LVLBPLUS + EDITOR_LEVELBREITE) as integer
        for e as integer = 0 to EDITOR_EBENEN-1
          for i as integer = EDITOR_LVLBPLUS+1 to EDITOR_LVLBPLUS + EDITOR_LEVELBREITE
            temp(i) = editorfeld(i, EDITOR_LVLHPLUS + EDITOR_LEVELHOEHE, e)
            for k as integer = EDITOR_LVLHPLUS + EDITOR_LEVELHOEHE to EDITOR_LVLHPLUS+2 step -1
              editorfeld(i, k, e) = editorfeld(i, k-1, e)
              if e = edit.ebene then stein i, k, editorfeld(i, k, e), e
            next
            editorfeld(i, EDITOR_LVLHPLUS+1, e) = temp(i)
            if e = edit.ebene then stein i, EDITOR_LVLHPLUS+1, temp(i)
          next
        next
        editor_undoreset edit
        edit.geaendert = -1
      ' Level spiegeln
      case "x", "X"
        editor_levelSpiegeln "x", edit.ebene
        editor_undoreset edit
        edit.geaendert = -1
      case "y", "Y"
        editor_levelSpiegeln "y", edit.ebene
        editor_undoreset edit
        edit.geaendert = -1
      case "1" to "9"  ' Ebenen
        if val(taste) <> edit.ebene+1 and val(taste) <= EDITOR_EBENEN then
          print taste
          edit.ebene = val(taste) - 1
          for i as ubyte = 1 to EDITOR_LVLBPLUS + EDITOR_LEVELBREITE
            for k as ubyte = 1 to EDITOR_LVLHPLUS + EDITOR_LEVELHOEHE
              stein i, k, editorfeld(i, k, edit.ebene), edit.ebene
            next
          next
        end if
    end select
    sleep 1
  loop
end sub

sub editor_levelSpiegeln(richtung as string, aktiveEbene as integer)
  dim as integer tausch
  select case richtung
    case "x"
      for e as integer = 0 to EDITOR_EBENEN-1
        for i as integer = 1 to EDITOR_LVLBPLUS + (EDITOR_LEVELBREITE+1)\2
          for k as integer = EDITOR_LVLHPLUS+1 to EDITOR_LVLHPLUS + EDITOR_LEVELHOEHE
            tausch = EDITOR_LVLBPLUS + EDITOR_LEVELBREITE + 1 - i
            swap editorfeld(i+EDITOR_LVLBPLUS, k, e), editorfeld(tausch, k, e)
            editorfeld(i+EDITOR_LVLBPLUS, k, e) = editor_spiegeln("x", editorfeld(i+EDITOR_LVLBPLUS, k, e))
            editorfeld(tausch, k, e) = editor_spiegeln("x", editorfeld(tausch, k, e))
            if e = aktiveEbene then
              stein i+EDITOR_LVLBPLUS, k, editorfeld(i+EDITOR_LVLBPLUS, k, e), e
              stein tausch, k, editorfeld(tausch, k, e), e
            end if
          next
        next
      next
    case "y"
      for e as integer = 0 to EDITOR_EBENEN-1
        for i as integer = EDITOR_LVLBPLUS+1 to EDITOR_LVLBPLUS + EDITOR_LEVELBREITE
          for k as integer = 1 to (EDITOR_LEVELHOEHE+1)\2
            tausch = EDITOR_LVLHPLUS + EDITOR_LEVELHOEHE + 1 - k
            swap editorfeld(i, k+EDITOR_LVLHPLUS, e), editorfeld(i, tausch, e)
            editorfeld(i, k+EDITOR_LVLHPLUS, e) = editor_spiegeln("y", editorfeld(i, k+EDITOR_LVLHPLUS, e))
            editorfeld(i, tausch, e) = editor_spiegeln("y", editorfeld(i, tausch, e))
            if e = aktiveEbene then
              stein i, k+EDITOR_LVLHPLUS, editorfeld(i, k+EDITOR_LVLHPLUS, e), e
              stein i, tausch, editorfeld(i, tausch, e), e
            end if
          next
        next
      next
  end select
end sub

sub editor_neu(edit as TypEditorumgebung)
  ' initiiert ein leeres Level
  for i as ubyte = EDITOR_LVLBPLUS + 1 to EDITOR_LVLBPLUS + EDITOR_LEVELBREITE
    for k as ubyte = EDITOR_LVLHPLUS + 1 to EDITOR_LVLHPLUS + EDITOR_LEVELHOEHE
      for e as ubyte = 0 to EDITOR_EBENEN - 1
        editorfeld(i, k, e) = 0
      next
      stein i, k, 0, 0
    next
  next
  for i as ubyte = 1 to EDITOR_LVLBPLUS + EDITOR_LEVELBREITE
    for k as ubyte = 1 to EDITOR_LVLHPLUS + EDITOR_LEVELHOEHE
      stein i, k, editorfeld(i, k, 0), 0
    next
  next
  editor_undoreset edit
  zeit = EDITOR_ZEITMIN
end sub

sub editor_rubberbox(x1 as integer, y1 as integer, x2 as integer, y2 as integer)
  if x1 < 0 or x2 < 0 then exit sub
  if x2 < x1 then swap x1, x2
  if y2 < y1 then swap y1, y2
  for i as integer = x1 to x2
    pset (i, y1), point(i, y1) xor &hffffff
    pset (i, y2), point(i, y2) xor &hffffff
  next
  for i as integer = y1 to y2
    pset (x1, i), point(x1, i) xor &hffffff
    pset (x2, i), point(x2, i) xor &hffffff
  next
end sub

function editor_setwahl as string
  dim as string taste, temp, eingabe
  dim as integer start = lbound(levelname)
  do
    cls
    print
    print " Waehlen Sie das Levelset aus, das Sie bearbeiten wollen."
    print
    for i as integer = 0 to 9
      if start + i > ubound(levelname) then exit for
      print " <" & i & "> Levelset " & left(levelname(start+i), len(levelname(start+i))-4)
    next
    print
    print " <n> neues Level anlegen"
    if ubound(levelname) - lbound(levelname) > 9 then print " Pfeiltasten auf/ab: blaettern"
    print " <ESC> Programm beenden"
    do
      taste = inkey
      select case taste
        case "0" to "9"  ' Set auswaehlen
          if start + val(taste) <= ubound(levelname) then return levelname(start + val(taste))
        case chr(255, 72)
          start -= 10
          if start < lbound(levelname) then start = lbound(levelname)
          exit do
        case chr(255, 80)
          if start + 10 <= ubound(levelname) then start += 10
          exit do
        case "n", "N"  ' neues Level
          temp = inputt(20, 2, "Gib einen Namen fuer das Set ein: ", "dddddddddddddd", "")
          if temp = "" or temp = chr(27) then exit do
          temp &= ".lev"
          if dir(EDITOR_LEVELPFAD & temp) <> "" then
            eingabe = inputt(24, 2, "Das Levelset existiert bereits. Willst du es laden? ", "?", "")
            if lcase(eingabe) = "n" then exit do
            return temp
          end if
          redim preserve levelname(lbound(levelname) to ubound(levelname)+1)
          levelname(ubound(levelname)) = temp
          editor_setoptionen temp
          return temp
        case chr(27)        : return ""
        case chr(255) & "k" : end
      end select
      sleep 1
    loop
  loop
end function

sub editor_ueberblick(levname as string, init as integer = 0)
  static as integer start = 1
  dim as integer aktuell, posX, posY, mx, my, mr, mralt, mb, x, y, ret, markiert = 0
  dim as integer xfakt = EDITOR_LEVELBREITE*(EDITOR_STEINBREITE\EDITOR_STEINFAKTOR)
  dim as integer yfakt = EDITOR_LEVELHOEHE*(EDITOR_STEINHOEHE\EDITOR_STEINFAKTOR)
  dim as integer yplus = EDITOR_LVLHPLUS*EDITOR_STEINHOEHE
  dim as string taste
  if init > 0 then start = init
  do
    cls
    aktuell = start
    for k as integer = 0 to EDITOR_STEINFAKTOR-1
      for i as integer = 0 to EDITOR_STEINFAKTOR-1
        if aktuell > levanz then exit for, for
        laden levname, aktuell
        posX = i*xfakt
        posY = k*yfakt+yplus
        kleinesFeld posX, posY, feld()
        if markiert = aktuell then
          line (posX, posY)-step(xfakt-1, yfakt-1), &hff0000, b
        else
          line (posX, posY)-step(xfakt-1, yfakt-1), &hffffff, b
        end if
        aktuell += 1
      next
    next
    windowtitle EDITOR_WINTITEL & " - " & levname & ", Level " & start & " - " & (aktuell-1) & " von " & levanz
    if yplus > 50 then
      if start <= levanz then
        draw string (20, 20), "Level " & start & " - " & (aktuell-1)
        if markiert then draw string (150, 20), "markiert: Level " & markiert
      end if
    end if
    do
      getmouse mx, my, mralt
      do
        getmouse mx, my, mr, mb
        taste = inkey
        if mb >= 0 then
          if mr > mralt then
            taste = chr(255, 72)
          elseif mr < mralt then
            taste = chr(255, 80)
          end if
          mr = mralt
        end if
        sleep 1
      loop until mb > 0 or taste <> ""
      select case taste
        case chr(255, 80)
          if aktuell <= levanz then
            start += EDITOR_STEINFAKTOR*(EDITOR_STEINFAKTOR-1)
            exit do
          end if
        case chr(255, 72)
          if start > 1 then
            start -= EDITOR_STEINFAKTOR*(EDITOR_STEINFAKTOR-1)
            if start < 1 then start = 1
            exit do
          end if
        case chr(27)        : exit sub
        case chr(255) & "k" : end
        case "o", "O"       : editor_setoptionen levname : continue do
        case "h", "H"       : editor_hilfe : continue do
        case "n", "N"       : editor_level levname, levanz+1 : exit do
        case "r", "R"
          if editor_frage("Levelset reorganisieren?") then reorganisation(levname) : continue do
        case "k"
          if levanz = 1 then
            editor_meldung("Sie koennen das letzte Level\neines Sets nicht loeschen.")
          elseif markiert = 0 then
            editor_meldung("Markieren Sie zuerst das Level,\nWelches Sie loeschen wollen.")
          elseif editor_frage("Wollen Sie das Level Nr. " & markiert & "\nwirklich aus dem Set loeschen?") then
            loeschen levname, markiert
            markiert = 0
            exit do
          end if
        case chr(255, 75)
          if markiert > 1 then
            verschieben levname, markiert, markiert-1
            markiert -= 1
            exit do
          end if
        case chr(255, 77)
          if markiert > 0 and markiert < levanz then
            verschieben levname, markiert, markiert+1
            markiert += 1
            exit do
          end if
      end select
      if my > yplus and mx < EDITOR_LEVELBREITE*EDITOR_STEINBREITE then
        if mb <> 0 then
          x = mx \ xfakt
          y = (my-yplus) \ yfakt
          ret = start + x + y*EDITOR_STEINFAKTOR
          if ret < start or ret > levanz then continue do
          if mb = 1 then
            do
              getmouse mx, my,, mb
              sleep 1
            loop until mb = 0
            editor_level levname, ret
            exit do
          elseif mb = 2 then
            if yplus > 50 then line (150, 20)-step(160, 16), 0, bf
            if markiert = ret then
              line (x*xfakt, y*yfakt+yplus)-step(xfakt-1, yfakt-1), &hffffff, b
              markiert = 0
            else
              for k as integer = 0 to EDITOR_STEINFAKTOR-1
                for i as integer = 0 to EDITOR_STEINFAKTOR-1
                  if start + i + k*EDITOR_STEINFAKTOR <= levanz then
                    line (i*xfakt, k*yfakt+yplus)-step(xfakt-1, yfakt-1), &hffffff, b
                  end if
                next
              next
              line (x*xfakt, y*yfakt+yplus)-step(xfakt-1, yfakt-1), &hff0000, b
              markiert = ret
              if yplus > 50 then draw string (150, 20), "markiert: Level " & markiert
            end if
            do
              getmouse mx, my,, mb
              sleep 1
            loop until mb = 0
          end if
        end if
      end if
    loop
  loop
end sub

sub editor_undoreset(edit as TypEditorumgebung)
  edit.geaendert = 0
  edit.undostart = 0
  edit.undoende = 0
  edit.undopos = 0
  edit.undogeschoben = 0
  edit.ebene = 0
end sub

sub editor_zeit(x as ubyte, y as ubyte)
  if y < 4 then
    locate 1, 66
    print "Zeit: " & zeit & "  "
  else
    editor_leseopt(x, y)
  end if
end sub

function inputt(z as ubyte, s as ubyte, txt as string, muster as string, byref vorgabe as string) as string
  ' formatierte Eingabe an der Stelle z/s
  ' txt: Ausgabetext; muster: Eingabemuster (siehe mustertest); ret: Eingabe (kann vorbelegt werden)
  ' Rueckgabewert: Eingabe oder chr(27) oder chr(255)+"k"
  ' ACHTUNG: Es findet keine Sicherheitspruefung statt.
  dim as string taste, eingabe, m = muster & "$"
  eingabe = left(vorgabe, len(muster))
  dim as ubyte position = len(eingabe)
  locate z, s
  print txt & vorgabe & string(len(muster)-len(vorgabe), "_");
  s += len(txt)
  do
    taste = inkey
    if mustertest(asc(taste), muster[position]) then
      'locate z, s + position
      locate z, s + position
      print taste;
      position += 1
      eingabe &= taste
    end if
    if asc(taste) = 8 and position > 0 then
      position -= 1
      locate z, s + position
      print "_";
      eingabe = left(eingabe, position)
    end if
    sleep 1
  loop until taste=chr(13) or taste=chr(27) or taste=chr(255)+"k"
  locate z, s - len(txt)
  print string(len(txt & muster), 32)
  if taste=chr(13) then return eingabe
  return taste
end function

function mustertest(wert as ubyte, muster as ubyte) as byte
  ' testet, ob wert auf das Muster muster passt
  ' unterstuetzt werden: 0 (Zahl), a/A (Buchstabe), d (Zahl/Buchstabe/_/-), * (ASCII), ? (j/y/n)
  dim as ubyte art
  select case wert
    case 48 to 57                  ' Zahlen
      if muster=48 or muster=68 or muster=100 or muster=42 then return -1
    case 74, 78, 89, 106, 110, 121 ' Frage (j/y/n)
      if muster=63 or muster=65 or muster=97 or muster=68 or muster=100 or muster=42 then return -1
    case 65 to 90, 97 to 122       ' Buchstaben
      if muster=65 or muster=97 or muster=68 or muster=100 or muster=42 then return -1
    case 45, 95                    ' Unter- und Bindestrich
      if muster=68 or muster=100 or muster=42 then return -1
    case 32 to 126                 ' sonstige ASCII-Zeichen
      if muster=42 then return -1
  end select
  return 0
end function

