const VERSIONSNUMMER = "3.04"
const REVISION = "110128"
const REVSTABLE = "110128"
#define MIN(x, y) ( iif(x<y, x, y) )
#define MAX(x, y) ( iif(x>y, x, y) )
#define MUSIC_MENU &h12
#define MUSIC_INGAME &h1

dim shared grafiktyp as string*4, grafikordner as string, DEBUG as byte = 0
dim shared as string*3 monat(11) = {"Jan", "Feb", "Mar", "Apr", "Mai", "Jun", _
                                    "Jul", "Aug", "Sep", "Okt", "Nov", "Dez"}
redim shared as string hilfsmeldung()
const menschMax = 10

grafikordner = "grafik/"
grafiktyp = ".bmp"

type TypSpiegel
  as string href
  as ubyte naechster, dreh, reflektl, reflektr, reflekto, reflektu, sicht
  as any ptr bild, bild1, bild2, bild3, bild4, bildklein
  declare destructor   ' loescht den Bildspeicher
end type
type TypMensch
  as integer x, y, xx(0 to menschMax-1), yy(0 to menschMax-1), bewegdauer, anz, akt
  as byte bewegx, bewegy
  as integer gegner, diamanten, laser, gegnersiege, diamantsiege, lasersiege, siege, bisher, punkte, leben
  as any ptr aktuellbild, bild(4, 4) ' bild(richtung, frame); Sitzmenschen umgekehrt
  declare destructor   ' loescht den Bildspeicher
end type
type TypThread
  ' sonder: 0: normal, 1: Impulsstein, 2: von Impulsstein geschoben, 3: zerbrechender Stein
  as byte x, y, dauer, bewegx, bewegy, sonder, ausloeser
  as ushort nr, zaehl
end type
type TypSpielergebnis
  as byte restzeit, leben, laser, diamant, typ
end type
type TypKoordinate
  as ubyte x, y
end type

declare sub anleitung
declare sub bewegen(nr as ubyte, r as ubyte)
declare function bildschirm_speichern as any ptr
declare sub bildschirm_zuruecksetzen(speicher as any ptr)
declare sub einstellungen
declare sub feldinit(set as string, nr as integer, tausch as integer, wdh as integer)
declare function font_laden(datei as string) as any ptr
declare sub kleinesFeld(x as integer, y as integer, feld() as ushort)
declare sub ladeinfo(set as string, byref typ as ubyte, byref kommentar as string, _
                     byref autor as string, byref version as ushort)
declare sub laden(set as string, nr as ubyte = 0)
declare function lasertest(x as ubyte, y as ubyte, r as ubyte) as ubyte
declare sub levelSpiegeln(richtung as string)
declare sub loeschen(set as string, nr as ubyte)
declare sub meldung(text as string)
declare function pload(datei as string) as any ptr
declare sub programmende
declare sub programminit
declare sub quicksort(array() as string, start as ubyte = 0, ende as ubyte = 255)
declare sub rechne(x as ubyte, y as ubyte, r as ubyte = 0)
declare sub rechneweg(x as ubyte, y as ubyte, r as ubyte = 0, opt as ubyte = 0)
declare sub rechneweg_abschluss
declare sub reorganisation(set as string)
declare sub schlachtStatistik(typ as integer, nr as integer)
declare function sound_laden(datei as string) as uinteger
declare sub sound_spielen(effekt as uinteger)
declare sub speichereinfo(set as string, typ as ubyte, kommentar as string, _
                          autor as string, version as ushort)
declare sub speichern(set as string, nr as ubyte = 0)
declare function spiel(set as string, nr as ubyte, wdh as integer = 0) as TypSpielergebnis
declare sub startmenu(nr as ubyte = 0)
declare sub stein(x as ubyte, y as ubyte, nr as ushort = 255, stellung as ubyte = 255)
declare sub stklein(x as ushort, y as ushort, bild as any ptr, gfxmod as ubyte)
declare function tastendruck as string
declare function threadneu(a as ubyte, x as ubyte, y as ubyte, dauer as ubyte) as TypThread
declare sub threadloeschen(thread as TypThread)
declare sub threadstart(nr as ushort)
declare sub verschieben(set as string, nr1 as ubyte, nr2 as ubyte)
declare function versionssuche as longint
declare sub warte(richtung as string, stopp as integer = 0)
declare sub zeichnefeld(reihe as ubyte = 1)
declare sub zeichnemensch

dim shared as integer steuerung(1 to 2), letztesLevel = 1, startlevel, levelset, duelldauer
dim shared as integer zeigeInfo, zeitAn, spiegelnAn
dim shared as string letztesSet
dim shared as ushort levanz, feld(34, 25), laser(33, 25), _MODUS_, AnzahlThreads
dim shared zeit as short, modus as string*6
dim shared as integer AnzahlSpiegel, AnzahlLaser, AnzahlZurueck
dim shared as TypKoordinate zurueck(1 to 255)
dim shared spiegel(127) as TypSpiegel, mensch(1 to 2) as TypMensch, thread(990) as TypThread
dim shared as integer figurwechsel(1 to 2), ausloeser, schlachtfolge()
dim shared menubild as any ptr, dummy as byte, wartefrei(1 to 2) as byte
redim shared levelname(1 to 1) as string, anzeigename(1 to 1) as string
dim shared speicherversion as ushort = 300, sound as ubyte
dim shared as single js_x1, js_y1, js_e1 = .95, js_x2, js_y2, js_e2 = .95
dim shared as integer js_b1, js_b2
dim shared as uinteger sound_musik, sound_laser, sound_dreh, sound_bruch
dim shared as any ptr font, laserSenk, laserWaag
dim shared typ as ubyte, kommentar as string*255, autor as string*63, version as ushort

enum rettyp
  retSieg = 1
  retTot1
  retTot2
  retBesiegt1
  retBesiegt2
  retZeitUm
  retPlus
  retMinus
  retAbbruch
end enum
enum steuertyp
  SPfeil = 0
  S4682
  SAdws
  SJoy1
  SJoy2
end enum

const B_O = 17, B_L = 30, B_R = 32, B_U = 31          ' Buchstabentasten WADS
const Z_O = 9,  Z_L = 5,  Z_R = 7,  Z_U = 3,  Z_M = 6 ' Zahlentasten 8462(5)
const P_O = 72, P_L = 75, P_R = 77, P_U = 80          ' Pfeiltaste ^<>v
const SOUND_MUSIK_AN = 1, SOUND_EFFEKT_AN = 2         ' Einstellungen fuer Sound
const SOUND_MUSIK_OK = 4, SOUND_EFFEKT_OK = 8         ' Einstellungen fuer Sound
const FILE_MUSIK = "sound/Lazer.mo3"
const FILE_LASER = "sound/laser.ogg"
const FILE_DREH  = "sound/dreh.ogg"
const FILE_BRUCH = "sound/bruch.ogg"

const OInfoAus = 0, OInfoEinmal = 1, OInfoImmer = 3, OZeitAn = 4, OSpiegelnAn = 8
